if (MCE!=undefined && MCE.applicationName=='Converter' && !MCE.finishedLoading) {
MCE.prefs.gui={
	currencyControlsInitialized: false,

	browserWindow: null,

	updateInterface:function()
	{
		var info=[{
			type:"INFO",
			desc:"Previous conversions will not be affected by changes in the preferences."
		}];
		document.getElementById('pref_custom_convert_selection').disabled=!document.getElementById('pref_selection_menu').checked;
		if (
			document.getElementById('pref_only_show_converted').checked || 
			document.getElementById("pref_replace_original").checked
		) {
			info.push({
				type:"WARNING",
				desc:"You have chosen to disable some of the Converter's default provisions "+
				"meant to ensure visual confirmation for conversions. Please be advised the Converter has "+
				"known limitations regarding the number of formats it is able to process, and disabling any "+
				"of the default provisions will result in ambiguity in specific cases."
			});
			if (document.getElementById('pref_auto_convert').checked) {
				info.push({
					type:'WARNING',
					desc:"In addition, you have chosen to auto-convert all pages. This option is "+
					"perfectly safe on its own, but since you have also disabled some of the "+
					"Converter's default confirmation provisions, the results can be particularly "+
					"misleading!"
				});
			}
		}
		if (
			document.getElementById('pref_currency_enabled').checked &&
			!document.getElementById('pref_myCurrency').value
		) {
			info.push({
				type:'WARNING',
				desc:"You have enabled currency conversions, but you haven't selected a preferred currency. "+
				"Please choose your currency if you want to use this functionality."
			});
		}
		if (document.getElementById('pref_thou_sep').value==document.getElementById('pref_dec_sep').value) {
			info.push({
				type:"WARNING",
				desc:"You have selected the same thousands separator and decimal separator; "+
				"this will result in ambiguous values."
			});
		}

		var contextualEnabled=document.getElementById('pref_selection_menu').checked;
		document.getElementById('label_default_unit').disabled=!contextualEnabled;
		document.getElementById('pref_default_unit').disabled=!contextualEnabled;
		
		document.getElementById('pref_in_fract').disabled=(
			document.getElementById('pref_metric').value==1 &&
			document.getElementById('pref_one_way').checked
		);

		// Buy/activate
		switch(this.getActivationAction()) {
			case "ACTIVATED INFO":
				document.getElementById('label_activate').label='(Activated)';
			case "INACTIVATED INFO":
				document.getElementById('button_buy_activate').label="What's this?";
				break;
			case "REACTIVATE":
				document.getElementById('button_buy_activate').label="Change key";
				document.getElementById('label_activate').label='(Already activated with a different key!)';
				info.push({
					type:"WARNING",
					desc:"You're changing a valid key, only proceed if you know what you're doing! Click Cancel to keep the current key."
				});
				break;
			case "ACTIVATE":
				document.getElementById('button_buy_activate').label="Activate";
				break;
		}

		var activated=(this.browserWindow.MCE.premium!=undefined);
		document.getElementById('pref_enable_precision_units').disabled=
		document.getElementById('pref_precision_units').disabled=
		document.getElementById('pref_enable_precision_currency').disabled=
		document.getElementById('pref_precision_currency').disabled=
		document.getElementById('pref_exchange_hours').disabled=
		document.getElementById('pref_enable_ws').disabled=
		document.getElementById('button_switch_currency').disabled=
		document.getElementById('pref_foreignCurrency').disabled=
			!activated;
		if (activated) {
			document.getElementById('pref_precision_units').disabled=
				!document.getElementById('pref_enable_precision_units').checked;
			document.getElementById('pref_precision_currency').disabled=
				!document.getElementById('pref_enable_precision_currency').checked;
			document.getElementById('button_switch_currency').disabled=(
				(document.getElementById('pref_foreignCurrency').value=='') ||
				(document.getElementById('pref_myCurrency').value=='')
			);
		}

		this.showInfo(info);
	},

	switchCurrencies:function()
	{
		var my=document.getElementById('pref_myCurrency').value;
		var foreign=document.getElementById('pref_foreignCurrency').value;
		if ((my=='') || (foreign=='')) return;
		document.getElementById('pref_myCurrency').value=foreign;
		document.getElementById('pref_foreignCurrency').value=my;
	},

	getActivationAction:function()
	{
		if (
			(this.browserWindow.MCE.premium!=undefined) &&
			(document.getElementById('premium_key').value==MCE.prefs.getPref('premium_key'))
		) { // Premium already activated, key unchanged
			return "ACTIVATED INFO";
		} else if (this.browserWindow.MCE.premium!=undefined) { // Activated, key changed
			return "REACTIVATE";
		} else if (document.getElementById('premium_key').value.length>0) { // Inactivated, key typed in
			return "ACTIVATE";
		} else { // Not activated, no key typed in
			return "INACTIVATED INFO";
		}
	},

	showInfo:function(info)
	{
		// Update warnings/info
		var ib=document.getElementById('infobox');
		while(ib.firstChild!=undefined) {
			ib.removeChild(ib.firstChild);
		}
		var i;
		var aLabel;
		var aDesc;
		for(i=0;i<info.length;i++) {
			aLabel=document.createElement("description");
			aDesc=document.createTextNode('* '+info[i].type+': '+info[i].desc);
			aLabel.appendChild(aDesc);
			if (info[i].type=='WARNING') {
				aLabel.style.color='#ff0000';
			} else if (info[i].type=='SUGGESTION') {
				aLabel.style.color='#009000';
			}
			aLabel.style.fontSize='90%';
			ib.appendChild(aLabel);
		}
	},

	findOpener:function(o)
	{
		if (o==undefined) {
			o=opener;
		}
		if (o.opener!=null) {
			return this.findOpener(o.opener);
		}
		return o;
	},

	loadAutoPrefs:function()
	{
		for(var pref in MCE.prefs.pref_descriptor) {
			if (MCE.prefs.isPrefManual(pref)) {
				continue;
			}
			
			var gui=document.getElementById(pref);
			if (gui==undefined) {
				alert("No GUI element found for "+pref);
				continue;
			}
			var prefType=MCE.prefs.getPrefType(pref);
			if (prefType=='boolean')
				gui.checked=MCE.prefs.getPref(pref);
			if (prefType=='string')
				gui.value=MCE.prefs.getPref(pref);
		}
	},

	saveAutoPrefs:function()
	{
		for(var pref in MCE.prefs.pref_descriptor) {
			if (MCE.prefs.isPrefManual(pref)) {
				continue;
			}
			
			var gui=document.getElementById(pref);
			if (gui==undefined) {
				alert("No GUI element found for "+pref);
				continue;
			}
			var prefType=MCE.prefs.getPrefType(pref);
			if (prefType=='boolean')
				var value=gui.checked;
			if (prefType=='string')
				var value=gui.value;
			MCE.prefs.setPref(pref,value);
		}
	},

	prefsOnLoad:function()
	{
		this.browserWindow=this.findOpener();

		this.loadAutoPrefs();

		document.getElementById("pref_24h").value=MCE.prefs.getPref('pref_24h')?'1':'0';
		document.getElementById("pref_metric").value=MCE.prefs.getPref('pref_metric')?'1':'0';
		document.getElementById("pref_celsius").value=MCE.prefs.getPref('pref_celsius')?'1':'0';
		document.getElementById("pref_in_fract").value=MCE.prefs.getPref('pref_in_fract')?'1':'0';

		// Currency
		document.getElementById("pref_currency_enabled").checked=MCE.prefs.getPref('pref_currency_enabled');
		this.initCurrencyControls();
		
                document.addEventListener('keyup',MCE.prefs.gui.keyPressed,false);

		// Last tab
		document.getElementById("tab-holder").selectedIndex=MCE.prefs.getPref("last_prefs_tab");

		return true;
	},
	
	prefsOnResize:function()
	{
		this.updateInterface();
	},

	keyPressed:function(e)
	{
		if (e.keyCode==27) {
			MCE.prefs.close_cancel();
		}
		if (e.keyCode==13) {
			MCE.prefs.close_ok();
		}
	},

	initCurrencyControls:function()
	{
		var list=document.getElementById("pref_myCurrency");
		var fList=document.getElementById("pref_foreignCurrency");
		var enabled=document.getElementById("pref_currency_enabled").checked;
		document.getElementById("pref_myCurrencyLabel").disabled=!enabled;
		list.disabled=!enabled;

		if (this.currencyControlsInitialized) {
			if (list.value && list.getItemAtIndex(0).value=='') {
				list.removeItemAt(0);
			}
			this.updateInterface();
			return true;
		}

		this.currencyControlsInitialized=true;

		fList.appendItem("(None)","","Disable foreign currency");
		var listIndex=MCE.util.inArray(MCE.prefs.getPref('pref_myCurrency'),MCE.currency.currencies);
		var fListIndex=MCE.util.inArray(MCE.prefs.getPref('pref_foreignCurrency'),MCE.currency.currencies);
		if (listIndex==-1) {
			listIndex=0;
			list.appendItem("(select your currency)",'');
		}
		if (fListIndex==-1) {
			fListIndex=0;
		} else {
			fListIndex++;
		}
		var cc; // Currency code
		var cn; // Currency name
		for(var i=0;i<MCE.currency.currencies.length;i++) {
			cc=MCE.currency.currencies[i];
			if (cc in MCE.currency.currency_names) {
				cn=' ('+MCE.currency.currency_names[cc]+')';
			} else {
				cn='';
			}
			list.appendItem(
				cc, /* label */
				cc, /* value */
				cn /* description */
			);
			fList.appendItem(cc,cc,cn);
		}
		list.selectedIndex=listIndex;
		fList.selectedIndex=fListIndex;
		return true;
	},

	close_ok:function()
	{
		if (
			document.getElementById("pref_currency_enabled").checked &&
			!document.getElementById("pref_myCurrency").value
		) {
			alert(
				"If you want to use the currency conversion features\n"+
				"you have to select the target currency."
			);
			return false;
		}
		MCE.prefs.setPref("pref_24h",document.getElementById("pref_24h").value=="1");
		MCE.prefs.setPref("pref_metric",document.getElementById("pref_metric").value=="1");
		MCE.prefs.setPref("pref_celsius",document.getElementById("pref_celsius").value=="1");
		MCE.prefs.setPref("pref_in_fract",document.getElementById("pref_in_fract").value=="1");
		MCE.prefs.setPref("pref_myCurrency",document.getElementById("pref_myCurrency").value); // NOT automatic!
		MCE.prefs.setPref("pref_foreignCurrency",document.getElementById("pref_foreignCurrency").value); // NOT automatic!

		if (MCE.prefs.getPref("premium_key")!=document.getElementById("premium_key").value) {
			if (!this.browserWindow.MCE.loadPremium(document.getElementById("premium_key").value)) {
				document.getElementById("premium_key").value='';
			}
		}
		this.saveAutoPrefs(); // KEEP THIS AFTER THE PREMIUM KEY TEST ABOVE!

		this.prefActions();
		if (this.browserWindow.MCE.premium!=undefined) {
			this.browserWindow.MCE.premium.processPrefs();
		}
		this.close_common();
	},

	close_cancel:function()
	{
		if (
			MCE.prefs.getPref("pref_currency_enabled") &&
			!MCE.prefs.getPref("pref_myCurrency")
		) {
			document.getElementById("pref_currency_enabled").checked=false;
			MCE.prefs.setPref("pref_currency_enabled",false);
			this.initCurrencyControls();
			
			alert(
				"Currency conversions have been disabled.\n"+
				"You can enable them at any time in the options dialog."
			);
		}
		/*
			Sometimes this is opened as modal. In that case, event listeners seem to
			be inherited by the opener. Failing to remove them causes the opener
			to misbehave (i.e. events still get captured by the modal window's listeners
			even after it gets closed, although that happens in a sick and twisted way
			which doesn't allow the listeners to actually perform; probably a bad case
			of good practice plus security concerns mangling this up).
		*/
		document.removeEventListener('keyup',MCE.prefs.gui.keyPressed,false);
		this.close_common();
	},

	close_common:function()
	{
		MCE.prefs.setPref("last_prefs_tab",document.getElementById("tab-holder").selectedIndex);
		window.close();
	},

	prefActions:function()
	{
		var myWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			.getService(Components.interfaces.nsIWindowMediator)
			.getMostRecentWindow("navigator:browser");
		myWindow.MCE.iface.initControls();
		return true;
	},

	buyActivate:function()
	{
		var key=document.getElementById("premium_key").value;
		switch(this.getActivationAction()) {
			case "ACTIVATED INFO":
			case "INACTIVATED INFO":
				this.browserWindow.MCE.iface.showLocation("http://converter.mozdev.org/premium_version.html");
				break;
			case "REACTIVATE":
			case "ACTIVATE":
				var old_premium=this.browserWindow.MCE.premium;
				if (this.browserWindow.MCE.loadPremium(key) && (this.browserWindow.MCE.premium!=undefined)) {
					MCE.prefs.setPref("premium_key",document.getElementById("premium_key").value);
					this.updateInterface();
				} else {
					document.getElementById('label_activate').label='(Activation failed)';
					this.browserWindow.MCE.premium=old_premium;
				}
		}
	},
}

}
